#!/sbin/sh
#VenomFileCheck - do not use without permission.
TempFolder="/tmp"
! [ -d $TempFolder ] && mkdir $TempFolder

AddPropSetting()
{
   [ -f $PropFile ] && sed -i "/^$2/d" $PropFile
   echo "Setting $2 to $3 in $PropFile"
   echo "$2=$3" >> $PropFile
}

if [ -n "$1" -a -n "$2" -a -n "$3" -a -n "$4" ]; then
   PropFile=$TempFolder/$1
   case "$3" in
      FileExists)
         FileExists=0
         [ -f $4 -o -d $4 ] && FileExists=1
         AddPropSetting $1 $2 $FileExists
      ;;
      CompareMd5)
         MD5Matches=0
         if [ -f $4 ]; then
            MD5=$(md5sum $4 | cut -d' ' -f1)
         else
            echo "ERROR: $4 doesn't exist"
         fi
         [[ $MD5 = $5 ]] && MD5Matches=1
         AddPropSetting $1 $2 $MD5Matches
      ;;
      TextExistsInFile)
         TextExists=0
         if [ -f $4 ]; then
            if grep -Fxq "$5" $4 1>/dev/null; then
               TextExists=1
            fi
         else
            echo "ERROR: $4 doesn't exist."
         fi
         AddPropSetting $1 $2 $TextExists
      ;;
      Sql)
         if [ -f $4 ]; then
            if [ -n "$5" ]; then
               echo "Filename: $4"
               echo "** sqlite3 $4 \"$5\""
               SqlQueryResult=$(sqlite3 $4 "$5")
               HasRows=0
               [ -n "$SqlQueryResult" ] && HasRows=1
               AddPropSetting $1 $2 $HasRows
            else
               echo "Missing sql query: $5"
            fi
         else
            echo "ERROR: $4 doesn't exist."
         fi
      ;;
      *)
         echo "ERROR: Invalid argument: $3"
      ;;
   esac
else
   echo "Usage: CheckFile.sh <PropFile> <PropSetting> <CheckType> <Filename/Folder>"
fi
